-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["WARRIOR"] = {}
lib.classes["WARRIOR"][2] = function ()

	cfg.spells={}
	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("strike",{88161}) -- Strike
	lib.AddSpell("bt",{23881}) -- Bloodthirst
	lib.AddSpell("rb",{85288}) -- Raging Blow	
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("cs",{86346}) -- Colossus Smash
	lib.AddSpell("slam",{1464}) -- Slam
	lib.AddSpell("execute",{5308}) -- Execute
	lib.AddSpell("bs",{6673}) -- Battle Shout
	lib.AddSpell("dw",{12292}) -- Death Wish
	lib.AddSpell("hs",{78}) -- Heroic Strike
				
	cfg.auras={}
	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
	lib.AddAura("Executioner",90806,"debuff","target") -- Executioner
	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
	lib.AddAura("dw",12292,"buff","player") -- Death Wish
		
	local plist = {}
	table.insert(plist,"hs")
	table.insert(plist,"bt")
	table.insert(plist,"execute")
	table.insert(plist,"rb")
	table.insert(plist,"cs")
	table.insert(plist,"slam_bs")
	table.insert(plist,"br")
	table.insert(plist,"bs")
	table.insert(plist,"end")

	cfg.plist=plist

	cfg.case = {}
	cfg.case = {
		["execute"] = function()
			local t,s = lib.GetAura({"Executioner"})
			if s<5 or (s==5 and t<2) then
				return lib.SimpleCDCheck("execute")
			end
			return nil
			-- return lib.BuffApply("execute","Executioner",nil,5)
		end,
		["rb"] = function()
			local t = lib.GetAura({"Enrage","dw","br"})
			if t>0 then
				return lib.SimpleCDCheck("rb")
			end
			return nil
			-- return lib.ApplyonAuras("rb",{"Enrage","br","dw"})
		end,
		["slam_bs"] = function ()
			local t = lib.GetAura({"bs"})
			if t>0 then
				return lib.SimpleCDCheck("slam") --lib.ApplyonAura("slam","bs")
			end
			return nil
		end,
		["br"] = function ()
			local t = lib.GetAura({"Enrage","dw","br"})
			if t==0 and lib.GetAura({"bs"})==0 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["hs"] = function ()
			--if lib.overlaping("hs") then return nil end
			if cfg.power == 100 then
				lib.SimpleCDCheck("hs")
			-- return lib.CDandPowerCheck("as",50)
			end
--			return lib.CDandPowerCheck("hs",90)
		end,
		["bs"] = function ()
			--if lib.overlaping("bs") then return nil end
			if cfg.power < cfg.spells["bt"].powerCost then
				lib.SimpleCDCheck("bs")
			-- return lib.CDandPowerCheck("as",50)
			end
--			return lib.CDandPowerCheck("bs",50,true)
		end,
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
				lib.UpdateBar(nil)
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("strike") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonupdate = function()
		lib.rangecheck()
	end
	
	cfg.onhealth=true
	cfg.onpower=true
	cfg.onupdate=true
	return true
end